"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.promise.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _defineProperty2() {
  const data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function () {
    return data;
  };

  return data;
}

function _pMapSeries() {
  const data = _interopRequireDefault(require("p-map-series"));

  _pMapSeries = function () {
    return data;
  };

  return data;
}

function _ramda() {
  const data = _interopRequireDefault(require("ramda"));

  _ramda = function () {
    return data;
  };

  return data;
}

function _componentDependencies() {
  const data = _interopRequireDefault(require("./component-dependencies"));

  _componentDependencies = function () {
    return data;
  };

  return data;
}

class VersionDependencies {
  constructor(component, dependencies, devDependencies, extensionsDependencies, sourceScope) {
    (0, _defineProperty2().default)(this, "component", void 0);
    (0, _defineProperty2().default)(this, "dependencies", void 0);
    (0, _defineProperty2().default)(this, "devDependencies", void 0);
    (0, _defineProperty2().default)(this, "extensionsDependencies", void 0);
    (0, _defineProperty2().default)(this, "allDependencies", void 0);
    (0, _defineProperty2().default)(this, "sourceScope", void 0);
    this.component = component;
    this.dependencies = dependencies;
    this.devDependencies = devDependencies;
    this.extensionsDependencies = extensionsDependencies;
    this.allDependencies = [...this.dependencies, ...this.devDependencies, ...this.extensionsDependencies];
    this.sourceScope = sourceScope;
  }

  async toConsumer(repo, manipulateDirData) {
    const depToConsumer = dep => dep.toConsumer(repo, manipulateDirData);

    const dependenciesP = Promise.all(this.dependencies.map(depToConsumer));
    const devDependenciesP = Promise.all(this.devDependencies.map(depToConsumer));
    const extensionDependenciesP = Promise.all(this.extensionsDependencies.map(depToConsumer));
    const componentP = this.component.toConsumer(repo, manipulateDirData);
    const [component, dependencies, devDependencies, extensionDependencies] = await Promise.all([componentP, dependenciesP, devDependenciesP, extensionDependenciesP]);
    return new (_componentDependencies().default)({
      component,
      dependencies,
      devDependencies,
      extensionDependencies
    });
  }

  async toObjects(repo, clientVersion, collectParents, collectArtifacts) {
    // for the dependencies, don't collect parents they might not exist
    const depsP = (0, _pMapSeries().default)(this.allDependencies, dep => dep.toObjects(repo, clientVersion, false, collectArtifacts));
    const compP = this.component.toObjects(repo, clientVersion, collectParents, collectArtifacts);
    const [component, dependencies] = await Promise.all([compP, depsP]);
    return [...component, ..._ramda().default.flatten(dependencies)];
  }

}

exports.default = VersionDependencies;